#include "stdafx.h"



__pragma (comment (lib, "tagapi.lib"))

__pragma (comment (lib, "user32.lib"))
__pragma (comment (lib, "setupapi.lib"))
__pragma (comment (lib, "winmm.lib"))
__pragma (comment (lib, "avrt.lib"))



namespace ThinAudioGateway {





/*
################################################################################################

Variables
================================================================================================

################################################################################################
*/





HINSTANCE DllInstance = 0;

wchar_t ExePath [MAX_PATH];
PCTSTR ExeFile = nullptr;

UINT DllRefCount = 0;           // DLL reference count



#if _Debug

  DebugContext Dbg = {L"tagdll", 7};

#endif





/*
################################################################################################

Functions
================================================================================================

################################################################################################
*/





#if _Debug

extern "C" void _stdcall SetGlobalDebugPrintLevel (UINT const Level) {

  static_cast <DebugContextC &> (Dbg).SetPrintLevelOffset (static_cast <int> (Level));

}

#endif // Debug





} // namespace





/*
DLL entry function
================================================================================================
*/

extern "C" BOOL WINAPI DllMain (HMODULE const Instance, DWORD const Reason, PVOID const Reserved) {

  Unreferenced (Reserved);



#if _Debug

  static PCTSTR const Reasons [] = {
    L"PROCESS_DETACH", L"PROCESS_ATTACH", L"THREAD_ATTACH", L"THREAD_DETACH"
  };

  Assert (Reason < NumArrayElems (Reasons));

#endif _Debug



  bool Result = false;



  switch (Reason) {
    
    case DLL_PROCESS_ATTACH: {

      Assert (DllRefCount == 0);

      {

        DllInstance = Instance;

        //DisableThreadLibraryCalls (Instance);



#if _Debug

        Debug (8, L"%s, API version %u", ProductName, ApiVersion);

#endif // _Debug



        if (GetModuleFileName (nullptr, ExePath, NumArrayElems (ExePath)) == 0) {

          Debug (9, L"Cannot get EXE path (%s)", LastErrorText ());

          goto ExitCase_Attach;

        }

        Assert (ExeFile == nullptr);

        ExeFile = wcsrchr (ExePath, L'\\');

        Assert (ExeFile != nullptr);

        ++ExeFile;

        Debug (8, L"Loading into process %u (%.80s)", GetCurrentProcessId (), ExeFile);

        Result = true;

      }

ExitCase_Attach:

      break;

    } // DLL_PROCESS_ATTACH



    case DLL_PROCESS_DETACH: {

      Assert (ExeFile != nullptr);

      Debug (8, L"Unloading from process %u (%.80s)", GetCurrentProcessId (), ExeFile);

      Assert (DllRefCount == 0);

      break;

    }



    case DLL_THREAD_ATTACH: {

      Debug (6, L"Attached to thread %u", GetCurrentThreadId ());

      break;

    }



    case DLL_THREAD_DETACH: {

      Debug (6, L"Detached from thread %u", GetCurrentThreadId ());

      break;

    }



  } // switch (Reason)



  Debug (6, L"Returning from DLL entry (%s) with %u", Reasons [Reason], Result);
                             
  return Result;

}
