#include "stdafx.h"





#if _LegacyWrappers





template <class Class> Class * FromVoid (void * const Obj) {

  Assert (Obj != nullptr);

  Class * const TypedObj = static_cast <Class *> (Obj);

  TypedObj->Check ();

  return TypedObj;

}





template <class Class> Class const * FromVoid (void const * const Obj) {

  Assert (Obj != nullptr);

  Class const * const TypedObj = static_cast <Class const *> (Obj);

  TypedObj->Check ();

  return TypedObj;

}





/*
################################################################################################

TagDriver class wrappers
================================================================================================

################################################################################################
*/





extern "C" {





HRESULT _Export _stdcall Driver_Create (void * * const Obj, GUID const * const ClassId) {

  return TagDriverC::Create (*reinterpret_cast <TagDriver * *> (Obj), *ClassId);

}





void _Export _stdcall Driver_Delete (void * const Drv) {

  TagDriverC * const DrvO = FromVoid <TagDriverC> (Drv);

  DrvO->Delete ();

}





bool _Export _stdcall Driver_IsFound (TagDriver const * const Drv) {

  TagDriverC const * const DrvO = FromVoid <TagDriverC> (Drv);

  return DrvO->IsFound ();

}





bool _Export _stdcall Driver_IsOpen (TagDriver const * const Drv) {

  TagDriverC const * const DrvO = FromVoid <TagDriverC> (Drv);

  return DrvO->IsOpen ();

}





HRESULT _Export _stdcall Driver_Find (void * const Drv) {

  TagDriverC * const DrvO = FromVoid <TagDriverC> (Drv);

  return DrvO->Find ();

}





void _Export _stdcall Driver_Forget (void * const Drv) {

  TagDriverC * const DrvO = FromVoid <TagDriverC> (Drv);

  return DrvO->Forget ();

}





HRESULT _Export _stdcall Driver_Open (void * const Drv) {

  TagDriverC * const DrvO = FromVoid <TagDriverC> (Drv);

  return DrvO->Open ();

}





void _Export _stdcall Driver_Close (void * const Drv) {

  TagDriverC * const DrvO = FromVoid <TagDriverC> (Drv);

  return DrvO->Close ();

}





HRESULT _Export _stdcall Driver_ControlRequest (
  void * const Drv,
  UINT const Func,
  DriverReq * const Req, LocSize const ReqSize,
  void * const Data, LocSize const DataSize,
  LocSize * const RetSize
) {

  TagDriverC * const DrvO = FromVoid <TagDriverC> (Drv);

  return DrvO->ControlRequest (Func, *Req, ReqSize, Data, DataSize, RetSize);

}





HRESULT _Export _stdcall Driver_GetInfo (void * const Drv, DriverInfo * const DI) {

  TagDriverC * const DrvO = FromVoid <TagDriverC> (Drv);

  return DrvO->GetInfo (*DI);

}





HRESULT _Export _stdcall Driver_GetLineList (
  void * const Drv, VirtualLineDesc * const Buffer, LocSize const Size, UINT * const NumLines
) {

  TagDriverC * const DrvO = FromVoid <TagDriverC> (Drv);

  return DrvO->GetLineList (Buffer, Size, *NumLines);

}





HRESULT _Export _stdcall Driver_CreateLine (void * const Drv, VirtualLineDesc const * const Desc) {

  TagDriverC * const DrvO = FromVoid <TagDriverC> (Drv);

  return DrvO->CreateLine (*Desc);

}





HRESULT _Export _stdcall Driver_DeleteLine (void * const Drv, UINT const Id) {

  TagDriverC * const DrvO = FromVoid <TagDriverC> (Drv);

  return DrvO->DeleteLine (Id);

}





HRESULT _Export _stdcall Driver_CreatePipe (
  void * const Drv, void * * const Pipe, UINT const LineId, bool const Capture
) {

  TagDriverC * const DrvO = FromVoid <TagDriverC> (Drv);

  return DrvO->CreatePipe (*reinterpret_cast <TagPipe * *> (Pipe), LineId, Capture);

}





#if _Debug

void _LinkageDecl _stdcall Driver_SetDebugPringLevelOffset (void * const Drv, int const Offset) {

  TagDriverC * const DrvO = FromVoid <TagDriverC> (Drv);

  DrvO->SetDebugPrintLevelOffset (Offset);

}

#endif





/*
################################################################################################

TagPipe class wrappers
================================================================================================

################################################################################################
*/





bool _Export _stdcall Pipe_IsCapt (void const * const Pipe) {

  TagPipeC const * const PipeO = FromVoid <TagPipeC> (Pipe);

  return PipeO->IsCapt ();

}





bool _Export _stdcall Pipe_IsOpen (void const * const Pipe) {

  TagPipeC const * const PipeO = FromVoid <TagPipeC> (Pipe);

  return PipeO->IsOpen ();

}





PCTSTR _Export _stdcall Pipe_GetDir (void const * const Pipe) {

  TagPipeC const * const PipeO = FromVoid <TagPipeC> (Pipe);

  return PipeO->GetDir ();

}





void _Export _stdcall Pipe_Delete (void * const Pipe) {

  TagPipeC * const PipeO = FromVoid <TagPipeC> (Pipe);

  PipeO->Delete ();

}





HRESULT _Export _stdcall Pipe_Open (void * const Pipe) {

  TagPipeC * const PipeO = FromVoid <TagPipeC> (Pipe);

  return PipeO->Open ();

}





void _Export _stdcall Pipe_Close (void * const Pipe) {

  TagPipeC * const PipeO = FromVoid <TagPipeC> (Pipe);

  PipeO->Close ();

}





_Export CommonDataDesc * _stdcall Pipe_GetCommonData (void * const Pipe) {

  TagPipeC * const PipeO = FromVoid <TagPipeC> (Pipe);

  return &PipeO->GetCommonData ();

}





HRESULT _Export _stdcall Pipe_ControlRequest (
  void * const Pipe,
  UINT const Func,
  DriverReq * const Req, LocSize const ReqSize,
  void * const Data, LocSize const DataSize,
  LocSize * const RetSize
) {

  TagPipeC const * const PipeO = FromVoid <TagPipeC> (Pipe);

  return PipeO->ControlRequest (Func, *Req, ReqSize, Data, DataSize, RetSize);

}





HRESULT _Export _stdcall Pipe_SetFormatRange (void * const Pipe, FormatRangeDesc const * const Range) {

  TagPipeC * const PipeO = FromVoid <TagPipeC> (Pipe);

  return PipeO->SetFormatRange (*Range);

}





HRESULT _Export _stdcall Pipe_SetDefaultFormat (void * const Pipe, WaveFormatDesc const * const Fmt) {

  TagPipeC * const PipeO = FromVoid <TagPipeC> (Pipe);

  return PipeO->SetDefaultFormat (*Fmt);

}





HRESULT _Export _stdcall Pipe_SetMinimumBufferLength (void * const Pipe, UINT const Mcs) {

  TagPipeC * const PipeO = FromVoid <TagPipeC> (Pipe);

  return PipeO->SetMinimumBufferLength (Mcs);

}





HRESULT _Export _stdcall Pipe_SetNotificationEvent (void * const Pipe, HANDLE const Event) {

  TagPipeC * const PipeO = FromVoid <TagPipeC> (Pipe);

  return PipeO->SetNotificationEvent (Event);

}





HRESULT _Export _stdcall Pipe_Notify (void * const Pipe, NTSTATUS const Code) {

  TagPipeC * const PipeO = FromVoid <TagPipeC> (Pipe);

  return PipeO->Notify (Code);

}





HRESULT _Export _stdcall Pipe_AdvanceDevicePosition (void * const Pipe, UINT const Frames) {

  TagPipeC * const PipeO = FromVoid <TagPipeC> (Pipe);

  return PipeO->AdvanceDevicePosition (Frames);

}





HRESULT _Export _stdcall Pipe_ResetDevicePosition (void * const Pipe) {

  TagPipeC * const PipeO = FromVoid <TagPipeC> (Pipe);

  return PipeO->ResetDevicePosition ();

}





#if _Debug

void _LinkageDecl _stdcall Pipe_SetDebugPringLevelOffset (void * const Pipe, int const Offset) {

  TagPipeC * const PipeO = FromVoid <TagPipeC> (Pipe);

  PipeO->SetDebugPrintLevelOffset (Offset);

}

#endif





/*
################################################################################################

TagHost class wrappers
================================================================================================

################################################################################################
*/





bool _Export _stdcall Host_IsCapt (void const * const Host) {

  TagHostC const * const HostO = FromVoid <TagHostC> (Host);

  return HostO->IsCapt ();

}





bool _Export _stdcall Host_IsStarted (void const * const Host) {

  TagHostC const * const HostO = FromVoid <TagHostC> (Host);

  return HostO->IsStarted ();

}





_Export PCTSTR _stdcall Host_GetDir (void const * const Host) {

  TagHostC const * const HostO = FromVoid <TagHostC> (Host);

  return HostO->GetDir ();

}





_Export CommonDataDesc const * _stdcall Host_GetCommonData (void const * const Host) {

  TagHostC const * const HostO = FromVoid <TagHostC> (Host);

  return &HostO->GetCommonData ();

}






HRESULT _Export _stdcall Host_Create (
  void * * const Obj, void * const Drv, UINT const LineId, bool const Capture,
  CopyDataFunc * const CopyData, void * const Context
) {

  Assert (Obj != nullptr && Drv != nullptr && CopyData != nullptr);

  return TagHostC::Create (
    *reinterpret_cast <TagHost * *> (Obj), reinterpret_cast <TagDriver *> (Drv), LineId, Capture, CopyData, Context
  );

}





void _Export _stdcall Host_Delete (void * const Host) {

  TagHostC * const HostO = FromVoid <TagHostC> (Host);

  return HostO->Delete ();

}





HRESULT _Export _stdcall Host_Start (
  void * const Host, FormatRangeDesc const * const FormatRange, WaveFormatDesc const * const DefFormat, UINT const MinBufMcs
) {

  Assert (FormatRange != nullptr);

  TagHostC * const HostO = FromVoid <TagHostC> (Host);

  return HostO->Start (FormatRange, DefFormat, MinBufMcs);

}





HRESULT _Export _stdcall Host_Stop (void * const Host) {

  TagHostC * const HostO = FromVoid <TagHostC> (Host);

  return HostO->Stop ();

}





HRESULT _Export _stdcall Host_EventLoop (void * const Host, UINT const PollPeriodMs) {

  TagHostC * const HostO = FromVoid <TagHostC> (Host);

  return HostO->EventLoop (PollPeriodMs);

}





#if _Debug

void _LinkageDecl _stdcall Host_SetDebugPringLevelOffset (void * const Host, int const Offset) {

  TagHostC * const HostO = FromVoid <TagHostC> (Host);

  HostO->SetDebugPrintLevelOffset (Offset);

}

#endif





} // extern "C"





#endif _LegacyWrappers
