namespace ThinAudioGateway {





class _LinkageDef TagDriverC : public TagDriver {

  FakeAssignmentOperator (TagDriverC)
  FakeCopyConstructor (TagDriverC)

  GUID const ClassId;
  wchar_t InterfacePath [MAX_PATH];
  HANDLE Connection;

#if _Debug

  DebugContextC Dbg;

#endif // _Debug

public:

  TagDriverC (GUID const & xClassId);
  virtual ~TagDriverC ();

  bool IsFound () const { return (*InterfacePath != L'\0'); }
  bool IsOpen () const { return (Connection != 0); }

  GUID const & GetClassId () const { return ClassId; }
  PCTSTR GetInterface () const { return InterfacePath; }

  static HRESULT _stdcall Create (TagDriver * & Obj, GUID const & xClassId);
  void Delete ();

  HRESULT Find ();
  void Forget () { *InterfacePath = L'\0'; }

  HRESULT Open ();
  void Close ();

  HRESULT ControlRequest (
    UINT const Func,
    DriverReq & Req, LocSize const ReqSize,
    void * const Data = nullptr, LocSize const DataSize = 0,
    LocSize * const RetSize = nullptr
  ) const;

  HRESULT GetInfo (DriverInfo & DI) const;
  HRESULT GetLineList (VirtualLineDesc * const Buffer, LocSize const Size, UINT & NumLines) const;
  HRESULT CreateLine (VirtualLineDesc const & Desc) const;
  HRESULT DeleteLine (UINT const Id) const;

  HRESULT CreatePipe (TagPipe * & Pipe, UINT const LineId, bool const Capture) const;

#if _Debug

  void SetDebugPrintLevelOffset (int const Offset);

#endif // _Debug

  void Check () const {

#if _Debug

    AssertIf (IsOpen (), IsFound ());

#endif

  }
  
};





} // namespace
