class Application {

  FakeCopyConstructor (Application)
  FakeAssignmentOperator (Application)

  HINSTANCE const Inst;

  HWND Window;
  HWND StatusWindow;

  TagDriver * Driver;

  Worker * Workers [NumLinesMax];

#if _Debug

  DebugContextC Dbg;

#endif // _Debug

  void DoMessageLoop () const;

  void _cdecl Error (PCTSTR const Format, ...) const;

  LRESULT WindowProc (HWND const Win, UINT const Msg, WPARAM const WP, LPARAM const LP);
  static LRESULT WINAPI WindowProcOuter (HWND const Win, UINT const Msg, WPARAM const WP, LPARAM const LP);

  HRESULT CreateMainWindow ();

  HRESULT CreateWorker (VirtualLineDesc const & VLD);
  HRESULT DeleteWorker (UINT const LineId);

  HRESULT StartAll ();
  HRESULT StopAll ();

  void CreateLine ();
  void DeleteLine ();

  static INT_PTR WINAPI CreateLineDialogProc (HWND const Dlg, UINT const Msg, WPARAM const WP, LPARAM const LP);
  static INT_PTR WINAPI DeleteLineDialogProc (HWND const Dlg, UINT const Msg, WPARAM const WP, LPARAM const LP);

public:

  Application (HINSTANCE const xInst);
  /*virtual*/ ~Application ();

  HINSTANCE GetInst () const { return Inst; }
  HWND GetWindow () const { return Window; }
  operator HWND () const { return Window; }
  TagDriver const * GetDriver () const { return Driver; }

  HRESULT Run ();

};





static UINT const StatusWindowId = 9999;
