#include "stdafx.h"



#if !UseLegacyWrappers

  __pragma (comment (lib, "tagapi.lib"))

#endif

__pragma (comment (lib, "user32.lib"))
__pragma (comment (lib, "comctl32.lib"))
__pragma (comment (lib, "comdlg32.lib"))
__pragma (comment (lib, "setupapi.lib"))
__pragma (comment (lib, "winmm.lib"))
__pragma (comment (lib, "avrt.lib"))





/*
################################################################################################

Variables
================================================================================================

################################################################################################
*/





#if _Debug

namespace ThinAudioGateway {

  DebugContext Dbg = {L"tagapp", 7};

}

#endif





/*
Main function
================================================================================================
*/

HRESULT Main (HINSTANCE const Inst) {

  HRESULT HR = E_I_PROCESSING_NOT_FINISHED;

  Application * const App = new Application (Inst);

  if (App == nullptr) {

    ::Error (0, L"No memory for application object");

    HR = E_OUTOFMEMORY;
    goto Exit;

  }

  HR = App->Run ();

Exit:

  if (App != nullptr) {

    delete App;

  }

  Assert (HR != E_I_PROCESSING_NOT_FINISHED);

  return HR;

}





/*
Entry function
================================================================================================
*/

int WINAPI WinMain (HINSTANCE const Inst, HINSTANCE const PrevInst, PSTR const Cmd, int const Show) {

  (void) (PrevInst && Cmd && Show);

  Debug (7, L"Started");

  HRESULT const Res = Main (Inst);

  return static_cast <int> (Res);

}
