/*
################################################################################################

Classes
================================================================================================

################################################################################################
*/





class Application;





class Worker : public CallbackInterface {

  FakeCopyConstructor (Worker)
  FakeAssignmentOperator (Worker)

  Application const & App;
  UINT const Id;
  bool const Capture;

  wchar_t EpName [50];

  TagHost * Host;

  HWND Dlg;

  wchar_t FilePath [MAX_PATH];

  HANDLE Thread;
  bool ThreadExitRequest;

  bool Started;

  WaveFormat Fmt;
  PBYTE FileData;
  LocSize FileSize;
  LocSize FilePos;

#if _Debug

  DebugContextC Dbg;

#endif // _Debug

  PCTSTR GetDir () const { return IsCapt ()? L"capture" : L"render"; }
  HANDLE GetThread () const { return Thread; }

  void EnableNonRealtimeControls (bool const Enable);

  HRESULT ReadDataFromFile ();
  HRESULT WriteDataToFile ();

  HRESULT SelectInputFile ();
  HRESULT SelectOutputFile ();

  HRESULT ThreadProc ();
  static DWORD WINAPI ThreadProcOuter (void * const Arg);

  void _cdecl Error (PCTSTR const Format, ...) const;

  void ResetControls ();

  INT_PTR DialogProc (UINT const Msg, WPARAM const WP, LPARAM const LP);
  static INT_PTR WINAPI DialogProcOuter (HWND const Dlg, UINT const Msg, WPARAM const WP, LPARAM const LP);

  HRESULT EventLoop ();

public:

  Worker (Application const & xApp, UINT const xId, bool const Capt, PCTSTR const xEpName);
  virtual ~Worker ();

  UINT GetId () const { return Id; }
  bool IsCapt () const { return Capture; }
  HWND GetDlg () const { return Dlg; }
  operator HWND () const { return Dlg; }
  bool IsStarted () const { return (GetThread () != 0); }

  HRESULT Init ();

  HRESULT Start ();
  HRESULT Stop ();



  // From CallbackInterface

  LocSize CopyData (void * const Addr, LocSize const Bytes);



  static LocSize CopyDataWrapper (void * const Context, void * const Addr, LocSize const Bytes);

};
