@echo off

setlocal

set TestEcho=
rem set TestEcho=echo

set "DriverInfFile=ThinAudioGateway_4d699d4a.inf"
set "DeviceHardwareId=ThinAudioGateway_4d699d4a-65a5-40ec-9875-8e6d5fc01e0c"
set "DeviceInstanceId=Root\ThinAudioGateway_4d699d4a\0000"



set DriverSubDir=driver
set MgrSubDir=wdmdrvmgr



set Mode=%~1

if "%Mode%" == "" (

  echo %~n0: install^|remove
  exit /b 99

)



if /i "%Mode%" == "install" (

  set Mode=install

) else if /i "%1" == "remove" (

  set Mode=remove

) else (

  echo %~n0: Invalid mode "%Mode%"
  exit /b 1

)



if /i "%PROCESSOR_ARCHITECTURE%" == "x86" (

  set CpuDir=x86

) else if /i "%PROCESSOR_ARCHITECTURE%" == "amd64" (

  set CpuDir=x64

) else if /i "%PROCESSOR_ARCHITECTURE%" == "arm64" (

  set CpuDir=arm64

) else (

  echo Unsupported architechture %PROCESSOR_ARCHITECTURE%
  exit /b 1

)



for /f "tokens=2 delims=[]" %%S in ('ver') do (

  for /f "tokens=2-5 delims=. " %%A in ("%%~S") do (

    set /a Ver1=%%A
    set /a Ver2=%%B
    set /a Ver3=%%C
    rem set /a Ver4=%%D

  )

)

for %%D in ("%~dp0..") do set "RootDir=%%~fD"

set InfFileSfx=

if %Ver1% LEQ 6 set InfFileSfx=_6x

for %%F in ("%DriverInfFile%") do set DriverInfFile=%%~nF%InfFileSfx%%%~xF



for %%D in ("%RootDir%\%DriverSubdir%") do set "InfDir=%%~fD"

set "MgrCmd=%RootDir%\%MgrSubDir%\%CpuDir%\wdmdrvmgr"



if "%Mode%" == "install" (

  %TestEcho% "%MgrCmd%" -q -h "%DeviceInstanceId%" -i "%DeviceHardwareId%" "%InfDir%\%DriverInfFile%"
  if errorlevel 1 exit /b 1

  echo Driver was installed successfully

) else (

  %TestEcho% "%MgrCmd%" -q -r "%DeviceHardwareId%"

  if errorlevel 1 exit /b 1

  echo Driver was removed successfully

)
